TOOL.Category   = "Render"
TOOL.Name       = "#Electroducer"
TOOL.Command    = nil
TOOL.ConfigName = nil
   
TOOL.ClientConVar["twitch"] 		= 1
TOOL.ClientConVar["sound"] 			= 1
TOOL.ClientConVar["effect"] 		= 1
TOOL.ClientConVar["mintwitchforce"] = -3500
TOOL.ClientConVar["maxtwitchforce"] = 3500
TOOL.ClientConVar["magnitude"] 		= 25
TOOL.ClientConVar["reps"] 			= 0
TOOL.ClientConVar["mindelay"] 		= 0
TOOL.ClientConVar["maxdelay"] 		= 0.3

if (CLIENT) then
language.Add("Tool_Electroducer_name","Electroducer")
language.Add("Tool_Electroducer_desc","ITS ALIIIVE!")
language.Add("Tool_Electroducer_0","Left click = Electroduce, right click = Stop")
end

function TOOL.BuildCPanel(CPanel)
  CPanel:AddControl("Header",{
                    Text        = "#Tool_Electroducer_name",
                    Text = "#Tool_Electroducer_desc"})
  CPanel:AddControl("CheckBox",{
                    Label       = "Twitch",
                    Text = "Should the entity twitch?",
                    Command     = "Electroducer_twitch"})
  CPanel:AddControl("CheckBox",{
                    Label       = "Sound",
                    Command     = "Electroducer_sound"})
  CPanel:AddControl("CheckBox",{
                    Label       = "Effect",
                    Command     = "Electroducer_effect"})
  CPanel:AddControl("Slider",{
                    Label       = "Minimum twitch force",
                    Min         = -10000,
                    Max         = 10000,
                    Command     = "Electroducer_mintwitchforce"})
  CPanel:AddControl("Slider",{
                    Label       = "Maximum twitch force",
                    Min         = -10000,
                    Max         = 10000,
                    Command     = "Electroducer_maxtwitchforce"})
  CPanel:AddControl("Slider",{
                    Label       = "Magnitude",
                    Type        = "How many teslas should be emitted?",
                    Min         = 0,
                    Max         = 50,
                    Command     = "Electroducer_magnitude"})
  CPanel:AddControl("Slider",{
                    Label       = "Number of Shocks",
                    Text = "How many shocks? (0 for infinite)",
                    Min         = 0,
                    Max         = 50,
                    Command     = "Electroducer_reps"})
  CPanel:AddControl("Slider",{
                    Label       = "Minimum Delay",
                    Text = "How much time is between the shocks?",
					Type        = "float",
                    Min         = 0,
                    Max         = 5,
                    Command     = "Electroducer_mindelay"})
  CPanel:AddControl("Slider",{
                    Label       = "Maximum Delay",
                    Text = "How much time is between the shocks?",
					Type        = "float",
                    Min         = 0,
                    Max         = 5,
                    Command     = "Electroducer_maxdelay"})
end

function TOOL:LeftClick(Trace)
  if not Trace.Entity:IsValid() then return false end
  if (CLIENT) then return true end
  local ent 		= Trace.Entity
  local reps 		= self:GetClientNumber("reps")
  local mindelay 	= self:GetClientNumber("mindelay")
  local maxdelay 	= self:GetClientNumber("maxdelay")
  timer.Create("Timer",0,reps,function()
  if not ent:IsValid() then timer.Destroy("Timer") end
  timer.Adjust("Timer",math.Rand(mindelay,maxdelay),reps)
  self:Effect(ent)
  self:Twitch(ent)
  self:Soundemitt(ent)
  end)
end

function TOOL:RightClick()
  timer.Destroy("Timer")
end

function TOOL:Soundemitt(ent)
  local sound 	= self:GetClientNumber("sound")
  if sound 		== 0 then return end
  ent:EmitSound("Weapon_StunStick.Activate")
end

function TOOL:Twitch(ent)
  local twitch 	= self:GetClientNumber("twitch")
  if twitch     == 0 then return end
  if not ent:GetPhysicsObject():IsValid() then return end
  local min 	= self:GetClientNumber("mintwitchforce")
  local max 	= self:GetClientNumber("maxtwitchforce")
  if min > max then min = 0 end
  if max < min then max = 0 end
  local TwitchX = math.random(min,max)
  local TwitchY = math.random(min,max)
  local TwitchZ = math.random(min,max)
  ent:GetPhysicsObject():ApplyForceCenter(Vector(TwitchX,TwitchY,TwitchZ))
end
  
function TOOL:Effect(ent)
  local effect 	= self:GetClientNumber("effect")
  if effect     == 0 then return end
  local magnitude 	= self:GetClientNumber("magnitude")
  local effect  	= EffectData()
  effect:SetOrigin(ent:GetPos())
  effect:SetStart(ent:GetPos())
  effect:SetMagnitude(magnitude)
  effect:SetEntity(ent)
  util.Effect("teslaHitBoxes",effect)
end